﻿
<#
Run Syntax
C:\Windows\System32\WindowsPowerShell\v1.0\powershell.exe & c:\Scripts\Script_Name.ps1
Requirements: Powershell V4, Embotics Powershell module 2.7 or higher
#>
###################################################################################################################################################  
###    Edit these for your Environment   ##########################################################################################################
###################################################################################################################################################      
$defaultVCmdrHostName = "your.vcommander.address"   #vCommander Host name or IP
$defaultEncryptedCredFilePath = "C:\Scripts\creds\superuser.xml" #API user crendential file.
$File_Location = "c:\Scripts\Reports\" #Output directory for csv file
###################################################################################################################################################
###################################################################################################################################################
#Reload modules 
        Write-Host "Loading Modules"
        $moduleName = "VCommanderRestClient"
        If (-not (Get-Module -name $moduleName)) {
                        Import-Module -Name $moduleName 
        } else {
                        Remove-Module $moduleName
                        Import-Module -Name $moduleName 
        }
        $moduleName = "VCommander"
        If (-not (Get-Module -name $moduleName)) {
                        Import-Module -Name $moduleName 
        } else {
                        Remove-Module $moduleName
                        Import-Module -Name $moduleName 
        }
#Setup vCommander connection
function Connect-VCmdr {
    $Global:SERVICE_HOST = $defaultVCmdrHostName
    $Global:BASE_SERVICE_URI = $Global:BASE_SERVICE_URI_PATTERN.Replace("{service_host}",$Global:SERVICE_HOST)
    $Global:CREDENTIAL = New-DecryptCredential -keyFilePath $defaultEncryptedCredFilePath
    VCommander\Set-IgnoreSslErrors
    Connect-Client
}
#Connect to vCommander
$connected = Connect-VCmdr
$orgid = $null
$OrganizationID = (Get-Organizations).OrganizationCollection.Organizations.id
ForEach ($orgid in $OrganizationID){
    Sleep 1
    $orgName = (Get-Organization -orgId $orgid).organization.name 
    #Get Org Quota Limits
    $OrgQuotalimit = (Get-Organization -orgId $orgid).Organization.resourceQuota | Select-Object -Property CPuCount,memoryInGB,storageInGB
    $OrgQuotaCPU = $OrgQuotalimit.CPUcount
        IF(!$OrgQuotaCPU){$OrgQuotaCPU = "Not_Configured"}
        IF($OrgQuotaCPU -gt "92000000000000000" ){$OrgQuotaCPU = "Unlimited"}
    $OrgQuotaMEM = $OrgQuotalimit.memoryInGB
        IF(!$OrgQuotaMEM){$OrgQuotaMEM = "Not_Configured"}
        IF($OrgQuotaMEM -contains "9.223372036854776E18" ){$OrgQuotaMEM = "Unlimited"}
    $OrgQuotaGB = $OrgQuotalimit.storageInGB
        IF(!$OrgQuotaGB){$OrgQuotaGB = "Not_Configured"}
        IF($OrgQuotaGB -contains "9.223372036854776E18" ){$OrgQuotaGB = "Unlimited"}
 #Get Available resources
    $OrgAvailable = (Get-QuotaStatistics -orgId $orgid).QuotaStatistics.resourceQuota
    $orgAvailableCPU = $OrgAvailable.CPUCount
        IF(!$OrgAvailableCPU){$OrgAvailableCPU = "Not_Configured"}
        IF($OrgAvailableCPU -gt "92000000000000000"){$OrgAvailableCPU = "Unlimited"}
    $orgAvailableMEM = $OrgAvailable.memoryInGB
        IF(!$OrgAvailableMEM){$OrgAvailableMEM = "Not_Configured"}
        IF($OrgAvailableMEM -contains "9.223372036854776E18"){$OrgAvailableMEM = "Unlimited"}
    $orgAvailableGB = $OrgAvailable.storageInGB
        IF(!$orgAvailableGB){$orgAvailableGB = "Not_Configured" }
        IF($OrgAvailableGB -contains "9.223372036854776E18"){$OrgAvailableGB = "Unlimited"}
        #Write-host "$orgname - $orgAvailableGB"
    
    #dump Into CSV
    $Date = Get-Date -UFormat "%Y.%m.%d"
    #Calculate Percentages
  
    Try{$PercentCPU = ($OrgAvailableCPU/$OrgQuotaCPU)*100}
        Catch{
             $PercentCPU = "Not_Configured"
             }
    Try{$PercentMEM = ($OrgAvailableMEM/$OrgQuotaMEM)*100}
        Catch{
             $PercentMEM = "Not_Configured"
             }
    Try{$PerCentStorage = ($orgAvailableGB/$OrgQuotaGB)*100}
        Catch{
             $PerCentStorage = "Not_Configured"
             }

    #Store the information from this run 
       [PSCustomObject]@{
       OrgName = $orgname
       CPU_Reservation = $OrgQuotaCPU 
       CPU_Available = $OrgAvailableCPU
       CPU_Percent_Available = $PercentCPU
       Memory_Reservation  = $OrgQuotaMEM
       Memory_Available = $OrgAvailableMEM
       Memory_Percent_Available = $PercentMEM
       Storage_Reservation = $OrgQuotaGB
       Storage_Available = $orgAvailableGB
       Storage_percent_Available = $PerCentStorage  
       } | Export-Csv $File_Location\Quotausage_$Date.csv -notype -append

}
         


